/***************************************************************
  T/SDAS-DDC1 DRR SIOX DCM definitions for C3x/C6x DSP. Rev.2C
  (C) MicroLAB Systems Ltd, 1998-2000

  Notes:
    1. This file must be used as .H header file for 32-bit
       C3x/C6x DSP environments of host TORNADO DSP system or
       controller.
    2. All commands are adjusted for 32-bit data words and
       occupy most significant 16-bit word.

****************************************************************/

#ifndef __SXDDC1_DEF__
#define __SXDDC1_DEF__		1



//============= peripherals definitions ===============

	//------- DAC-1/2
#define TSDAS_DDC1_DAC_DATA_BITMASK		0x0fff0000
#define TSDAS_DDC1_DAC_DATA_SHIFT		16

	//------- 16C450/16C550 UART
#define TSDAS_DDC1_UART_DATA_BITMASK		0x00ff0000
#define TSDAS_DDC1_UART_DATA_SHIFT		16
#define TSDAS_DDC1_UART_ADDR_BITMASK		0x07000000
#define TSDAS_DDC1_UART_ADDR_SHIFT		24

#define TSDAS_DDC1_UART_RDATA_RG		0x00
#define TSDAS_DDC1_UART_TDATA_RG		0x00
#define TSDAS_DDC1_UART_DIVL_RG			0x00
#define TSDAS_DDC1_UART_IE_RG			0x01
#define TSDAS_DDC1_UART_DIVH_RG			0x01
#define TSDAS_DDC1_UART_IID_RG			0x02
#define TSDAS_DDC1_UART_LCNTR_RG		0x03
#define TSDAS_DDC1_UART_MCNTR_RG		0x04
#define TSDAS_DDC1_UART_LSTAT_RG		0x05
#define TSDAS_DDC1_UART_MSTAT_RG		0x06

#define TSDAS_DDC1_UART_DIVL_38400		0x03
#define TSDAS_DDC1_UART_DIVH_38400		0x00
#define TSDAS_DDC1_UART_DIVL_19200		0x06
#define TSDAS_DDC1_UART_DIVH_19200		0x00
#define TSDAS_DDC1_UART_DIVL_9600		0x0c
#define TSDAS_DDC1_UART_DIVH_9600		0x00
#define TSDAS_DDC1_UART_DIVL_4800		0x18
#define TSDAS_DDC1_UART_DIVH_4800		0x00
#define TSDAS_DDC1_UART_DIVL_2400		0x30
#define TSDAS_DDC1_UART_DIVH_2400		0x00
#define TSDAS_DDC1_UART_DIVL_1200		0x60
#define TSDAS_DDC1_UART_DIVH_1200		0x00
#define TSDAS_DDC1_UART_DIVL_600		0xc0
#define TSDAS_DDC1_UART_DIVH_600		0x00

#define TSDAS_DDC1_UART_IE_DR			0x01
#define TSDAS_DDC1_UART_IE_TEMPTY		0x02
#define TSDAS_DDC1_UART_IE_RLINESTAT		0x04
#define TSDAS_DDC1_UART_IE_MSTAT		0x08

#define TSDAS_DDC1_UART_LCNTR_DLAB		0x80
#define TSDAS_DDC1_UART_LCNTR_WLEN5		0x00
#define TSDAS_DDC1_UART_LCNTR_WLEN6		0x01
#define TSDAS_DDC1_UART_LCNTR_WLEN7		0x02
#define TSDAS_DDC1_UART_LCNTR_WLEN8		0x03
#define TSDAS_DDC1_UART_LCNTR_STOP1		0x00
#define TSDAS_DDC1_UART_LCNTR_STOP2		0x04
#define TSDAS_DDC1_UART_LCNTR_NOPAR		0x00
#define TSDAS_DDC1_UART_LCNTR_ODDPAR		0x08
#define TSDAS_DDC1_UART_LCNTR_EVENPAR		0x18

#define TSDAS_DDC1_UART_IID_BITMASK		0x06
#define TSDAS_DDC1_UART_IID_RLINESTAT		0x00
#define TSDAS_DDC1_UART_IID_TEMPTY		0x04
#define TSDAS_DDC1_UART_IID_MSTAT		0x06

#define TSDAS_DDC1_UART_MCNTR_DTR		0x01
#define TSDAS_DDC1_UART_MCNTR_RTS		0x02
#define TSDAS_DDC1_UART_MCNTR_OUT1		0x04
#define TSDAS_DDC1_UART_MCNTR_OUT2		0x08

#define TSDAS_DDC1_UART_LSTAT_DR		0x01
#define TSDAS_DDC1_UART_LSTAT_OE		0x02
#define TSDAS_DDC1_UART_LSTAT_PE		0x04
#define TSDAS_DDC1_UART_LSTAT_FE		0x08
#define TSDAS_DDC1_UART_LSTAT_BI		0x10
#define TSDAS_DDC1_UART_LSTAT_THEMPY		0x20
#define TSDAS_DDC1_UART_LSTAT_TEMPTY		0x40

#define TSDAS_DDC1_UART_MSTAT_DCTS		0x01
#define TSDAS_DDC1_UART_MSTAT_DDSR		0x02
#define TSDAS_DDC1_UART_MSTAT_TERI		0x04
#define TSDAS_DDC1_UART_MSTAT_DDCD		0x08
#define TSDAS_DDC1_UART_MSTAT_CTS		0x10
#define TSDAS_DDC1_UART_MSTAT_DSR		0x20
#define TSDAS_DDC1_UART_MSTAT_RI		0x40
#define TSDAS_DDC1_UART_MSTAT_DCD		0x80


	//------- HSP50214 PDC
#define TSDAS_DDC1_PDC_DATA_BITMASK		0x00ff0000
#define TSDAS_DDC1_PDC_DATA_SHIFT		16
#define TSDAS_DDC1_PDC_ADDR_BITMASK		0x07000000
#define TSDAS_DDC1_PDC_ADDR_SHIFT		24

#define TSDAS_DDC1_PDC_HLD0_RG			0x00
#define TSDAS_DDC1_PDC_HLD1_RG			0x01
#define TSDAS_DDC1_PDC_HLD2_RG			0x02
#define TSDAS_DDC1_PDC_HLD3_RG			0x03
#define TSDAS_DDC1_PDC_WRADDR_RG		0x04
#define TSDAS_DDC1_PDC_RDADDR_RG		0x05


	//------- DIO-0/1
#define TSDAS_DDC1_DIO0_DATA_BITMASK		0x00010000
#define TSDAS_DDC1_DIO1_DATA_BITMASK		0x00020000
#define TSDAS_DDC1_DIO0_DIR_BITMASK		0x00040000
#define TSDAS_DDC1_DIO1_DIR_BITMASK		0x00080000
#define TSDAS_DDC1_DIO0_DATA0			0x00000000
#define TSDAS_DDC1_DIO0_DATA1			0x00010000
#define TSDAS_DDC1_DIO1_DATA0			0x00000000
#define TSDAS_DDC1_DIO1_DATA1			0x00020000
#define TSDAS_DDC1_DIO0_DIR_IN			0x00000000
#define TSDAS_DDC1_DIO0_DIR_OUT			0x00040000
#define TSDAS_DDC1_DIO1_DIR_IN			0x00000000
#define TSDAS_DDC1_DIO1_DIR_OUT			0x00080000

	//------- XSL-1/2
#define TSDAS_DDC1_XSL_FMT_WLEN_BITMASK		0x00030000
#define TSDAS_DDC1_XSL_FMT_CLKPOL_BITMASK	0x00040000
#define TSDAS_DDC1_XSL_FMT_CLKFRM_BITMASK	0x00080000

#define TSDAS_DDC1_XSL_FMT_WLEN16		0x00000000
#define TSDAS_DDC1_XSL_FMT_WLEN24		0x00010000
#define TSDAS_DDC1_XSL_FMT_WLEN32		0x00020000
#define TSDAS_DDC1_XSL_FMT_CLKPOL_NEG		0x00000000
#define TSDAS_DDC1_XSL_FMT_CLKPOL_POS		0x00040000
#define TSDAS_DDC1_XSL_FMT_CLKFRM_OFF		0x00000000
#define TSDAS_DDC1_XSL_FMT_CLKFRM_ON		0x00080000

#define TSDAS_DDC1_XSL_DATA16_BITMASK		0x3fff0000
#define TSDAS_DDC1_XSL_DATA24_BITMASK		0x3fffff00
#define TSDAS_DDC1_XSL_DATA32_BITMASK		0x3fffffff


//================ Host Commands ===============

	//---- DAC write commands
#define	TSDAS_DDC1_DAC1_WR_CMND			0x00000000
#define	TSDAS_DDC1_DAC2_WR_CMND			0x10000000

	//---- UART commands
#define	TSDAS_DDC1_UART_WR_CMND			0x28000000
#define	TSDAS_DDC1_UART_RD_CMND			0x20000000

	//---- PDC commands
#define	TSDAS_DDC1_PDC_WR_CMND			0x38000000
#define	TSDAS_DDC1_PDC_RD_CMND			0x30000000

	//---- DIO commands
#define	TSDAS_DDC1_DIO_WR_CMND			0x48000000
#define	TSDAS_DDC1_DIO_RD_CMND			0x40000000

	//---- XSL commands
#define	TSDAS_DDC1_XSL_SET_FMT_CMND		0x49000000
#define	TSDAS_DDC1_XSL_FMT_RD_CMND		0x41000000
#define	TSDAS_DDC1_XSL1_WR_CMND			0x80000000
#define	TSDAS_DDC1_XSL2_WR_CMND			0xC0000000

	//---- Receiver Data mode selector commands
#define	TSDAS_DDC1_SET_RCV_AUX_DATA_CMND	0x4A000000
#define	TSDAS_DDC1_SET_PDC_DATA_CMND		0x4A010000


//=============== SIO port configuration =====================
// recommended configuration for 60MHz C3x DSP:
//       XLen=Rlen=32bits
//       XCLK - Int,  RCLK - Ext
//       FSX - output (1), HS=0, XVAREN=RVAREN=0, XFSM=RFSM=0
//       CLKXP - active low (1), CLKRP - active high,
//       FSXP=FSRP - active low (1)

#define	TSDAS_DDC1_C3X_SIO_GCRG_DATA		0x003F1044
#define	TSDAS_DDC1_C3X_SIO_GCRG_GO_MASK		0x0c000000

#define	TSDAS_DDC1_C3X_SIO_XCRG_DATA		0x111
#define	TSDAS_DDC1_C3X_SIO_RCRG_DATA		0x111

#define TSDAS_DDC1_C3X_SIO_RXTCRG_DATA		0x8
#define TSDAS_DDC1_C3X_SIO_RXTCRG_GO_MASK	0x3
#define TSDAS_DDC1_C3X_SIO_RXTPERRG_DATA	0x2


// recommended configuration for C6201@200MHz and C6701@167MHz DSP:
//       XLen=Rlen=32bits
//       XCLK - Int,  RCLK - Ext
//       FSX - output on DX load event
//       CLKXP - active low (1), CLKRP - active high,
//       FSXP=FSRP - active low (1)
//	 CLKX = approx 15MHz

// SPCR: 0000 0000 0000 0000 0000 0000 0000 0000
// PCR:  0000 0000 0000 0000 0000 1010 0000 1110
// XCR:  0000 0000 0000 0001 0000 0000 1010 0000
// RCR:  0000 0000 0000 0001 0000 0000 1010 0000
// SRGR: 0010 0000 0000 0000 0000 0000 0000 1110

#define	TSDAS_DDC1_C6X_MCBSP_SPCR_DATA		0x00000000
#define	TSDAS_DDC1_C6X_MCBSP_PCR_DATA		0x00000a0e
#define	TSDAS_DDC1_C6X_MCBSP_XRCR_DATA		0x000100a0
#define	TSDAS_DDC1_C6201_MCBSP_SRGR_DATA	0x2000000e
#define	TSDAS_DDC1_C6701_MCBSP_SRGR_DATA	0x2000000b

#define	TSDAS_DDC1_C6X_MCBSP_SPCR_GO_MASK	0x00410001

//===========================================================
#endif	// end of DDC1 defs
